﻿using Infragistics.Calculations;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace FormulaEditorNArgs
{
	/// <summary>
	/// Interaction logic for MainWindow.xaml
	/// </summary>
	public partial class MainWindow : Window
	{
		public MainWindow()
		{
			InitializeComponent();
		}

		private void Button1_Click(object sender, RoutedEventArgs e)
		{
			var argumentCount = int.Parse(this.numArgs.Text);

			this.calcManager.RegisterUserDefinedFunction(
				new CustomCalculationFunction("MyAvg", args => args.Average(), argumentCount, argumentCount));

			var operands = CreateSampleOperands(argumentCount);
			this.formulaEditor.Formula = CreateFormula(operands);
			this.formulaEditor.DisplayFormulaEditorDialog();
		}

		private string CreateFormula(double[] operands)
		{
			return "MyAvg(" + string.Join(", ", operands) + ")";
		}

		private double[] CreateSampleOperands(int argumentCount)
		{
			var arguments = new double[argumentCount];
			for (int i = 0; i < argumentCount; i++)
			{
				arguments[i] = i;
			}

			return arguments;
		}

		private void Button2_Click(object sender, RoutedEventArgs e)
		{
			var argumentCount = int.Parse(this.numArgs.Text);
			var operands = CreateSampleOperands(argumentCount);
			var formula = CreateFormula(operands);
			var result = this.calcManager.CalculateFormula(formula);

			MessageBox.Show("Average: " + result.GetResolvedValue().ToString());
		}
	}
}
